Selecting an RTL language should install RTL capable terminal emulator

Bug #562130 reported by Usama Akkad on 2010-04-13
310
This bug affects 48 people
Affects Status Importance Assigned to Milestone
language-selector (Ubuntu)
Low
Unassigned

Bug Description

Binary package hint: language-selector

the default terminal gnome-terminal which is using vte is not able to display RTL text like Arabic,Farsi, Urdu or Hebrew and it's a known bug that is not likly to be fixed at all as vte developer said. see bug #263822

How ever Mlterm is ready to support variant of scripts including Arabic ,Hebrew and even Chinese.
see https://wiki.ubuntu.com/Mlterm

problem:
no terminal with RTL support

fix:
installing Mlterm for RTL by default

ProblemType: Bug
DistroRelease: Ubuntu 10.04
Package: language-selector 0.5.4
ProcVersionSignature: Ubuntu 2.6.32-20.29-generic-pae 2.6.32.11+drm33.2
Uname: Linux 2.6.32-20-generic-pae i686
Architecture: i386
CheckboxSubmission: 4190bdfb1b8df71969b6cbad70f1beb6
CheckboxSystem: 9c26adf6eed2f681ba41f94dd24c07e4
Date: Tue Apr 13 11:38:45 2010
EcryptfsInUse: Yes
InstallationMedia: Ubuntu-Netbook 10.04 "Lucid Lynx" - Alpha i386 (20100113)
PackageArchitecture: all
ProcEnviron:
 LANG=ar_SA.utf8
 SHELL=/bin/bash
SourcePackage: language-selector

Usama Akkad (damascene) wrote :
Emmet Hikory (persia) on 2010-04-13
Changed in language-selector (Ubuntu):
importance: Undecided → Low
status: New → Triaged
Usama Akkad (damascene) on 2010-04-13
tags: added: rtl
Yaron (sh-yaron) wrote :

Only for clarification: mlterm will not replace gnome-terminal, mlterm will be installed additionally

description: updated
foxynet (mahboule) wrote :

on aime bien avoir une selition

Emmet Hikory (persia) wrote :

Just as a note, I really don't think this really solves the core issue. VTE is embedded *all over the place*, especially as "see more" features for GUI application managers, and the apt text interface is particularly prone to being completely incomprehensible as a result of bug #263822. Adding mlterm automatically through langpack when installing RTL languages may help alleviate some user pain, but it's a trivial workaround to install it manually, and it's only needed for certain terminal applications: many users will happily use the system without ever using a terminal and so will only be exposed to the embedded VTE interfaces, so never benefit from the installation of mlterm.

Fro my point of view programs shouldn't even have translations for the
terminal (not in CLI programs and not in GUI with CLI programs). when
someone want to have help, as long as it's all in his language, only local
users may help.
CLI is for "professionals", that will have to know English anyway, so the
translation of the CLI is just pointless.

2010/4/14 Emmet Hikory <email address hidden>

> Just as a note, I really don't think this really solves the core issue.
> VTE is embedded *all over the place*, especially as "see more" features
> for GUI application managers, and the apt text interface is particularly
> prone to being completely incomprehensible as a result of bug #263822.
> Adding mlterm automatically through langpack when installing RTL
> languages may help alleviate some user pain, but it's a trivial
> workaround to install it manually, and it's only needed for certain
> terminal applications: many users will happily use the system without
> ever using a terminal and so will only be exposed to the embedded VTE
> interfaces, so never benefit from the installation of mlterm.
>
> --
> Selecting an RTL language should install and RTL capable terminal emulator
> https://bugs.launchpad.net/bugs/562130
> You received this bug notification because you are a member of Ubuntu
> Hebrew Translators, which is a direct subscriber.
>
> _______________________________________________
> Mailing list: https://launchpad.net/~ubuntu-l10n-he
> Post to : <email address hidden>
> Unsubscribe : https://launchpad.net/~ubuntu-l10n-he
> More help : https://help.launchpad.net/ListHelp
>

Fro my point of view when I install programs or input a command in a terminal the output shows options in cluttered Arabic letters, It should be at least readable .

Usama Akkad (damascene) wrote :

@persia & Ddorda

1. are you saying if you can't save all the issue don't save any? simply mlterm works vte doesn't for RTL
2. about embedding: were vte is embedded you can't input. were vte is embedded you don't get questions asking to press yes or no like with apt-get. embedding is a fancy feature. not vital (I think)
3. adding mlterm will solve most of the problems
4. do you think people should install packages to solve problems of installing RTL support?
5. it's not trivial to install a package to help user instead of throwing them to search in the web for fix
6. a look in TranslationProject.org tells that many terminal application is ready to be translated
7. terminal is vital. and some times easier than the GUI. most of the documents, wikis, forums are using Terminal in their howto's , guides and fixes. (I don't know why should I explain that to GNU/Linux user)
8. not only translated software is the problem. but also the command line text editors ,listing folder(ls), cat and any other command that deal with text will fail to display RTL correctly.

>CLI is for "professionals", that will have to know English anyway, so the
>translation of the CLI is just pointless.

!!!, I'll just say read above.

Usama, i'm not even talking about RTL issues, i'm taking about the the fact
translating CLI strings is just useless. if you you get logs of program in
Hebrew, you won't be able to help, but if it's in Engish, it doesn't matter
what is your local language, you'll be able to help.
I believe that what shpuld be fixed is not the supporting of RTL in the
terminal, but something much bigger.

2010/4/15 Usama Akkad <email address hidden>

> @persia & Ddorda
>
> 1. are you saying if you can't save all the issue don't save any? simply
> mlterm works vte doesn't for RTL
> 2. about embedding: were vte is embedded you can't input. were vte is
> embedded you don't get questions asking to press yes or no like with
> apt-get. embedding is a fancy feature. not vital (I think)
> 3. adding mlterm will solve most of the problems
> 4. do you think people should install packages to solve problems of
> installing RTL support?
> 5. it's not trivial to install a package to help user instead of throwing
> them to search in the web for fix
> 6. a look in TranslationProject.org tells that many terminal application is
> ready to be translated
> 7. terminal is vital. and some times easier than the GUI. most of the
> documents, wikis, forums are using Terminal in their howto's , guides and
> fixes. (I don't know why should I explain that to GNU/Linux user)
> 8. not only translated software is the problem. but also the command line
> text editors ,listing folder(ls), cat and any other command that deal with
> text will fail to display RTL correctly.
>
>
> >CLI is for "professionals", that will have to know English anyway, so the
> >translation of the CLI is just pointless.
>
> !!!, I'll just say read above.
>
> --
> Selecting an RTL language should install and RTL capable terminal emulator
> https://bugs.launchpad.net/bugs/562130
> You received this bug notification because you are a member of Ubuntu
> Hebrew Translators, which is a direct subscriber.
>
> _______________________________________________
> Mailing list: https://launchpad.net/~ubuntu-l10n-he
> Post to : <email address hidden>
> Unsubscribe : https://launchpad.net/~ubuntu-l10n-he
> More help : https://help.launchpad.net/ListHelp
>

please, if RTL isn't you issue then do as I did. go to #ubuntu-devel or #ubuntu-bug and ask them what you should do. me my self think you should open a new bug for your issue with CLI translating not here. please.

you think if some one was using a system with RTL language support installed he must go to English speakers to get help!? how they can help him if it require some interaction with the *translated* GUI

I think he will prefer to ask his language speakers

in00b (a3794193) wrote :

we need the same solution apply on kubuntu

Muhammad Negm (ravingeek) wrote :

Kubuntu already supports BIDI in Konsole

Shlomil (shlomister) wrote :

If Konsole works well then this bug should be fixed by upstream Gnome-terminal developers....
https://bugzilla.gnome.org/show_bug.cgi?id=321490

... Sounds like it's not going to happen, but maybe Gnome devs will change their minds given enough community pressure.

I'm pretty much against including mlterm in default installation process (even if installed only in the second stage).
MLTerm is not a Gnome app, it looks ugly and doesn't fit well with the Gnome desktop.

Using will be just an ugly workaround of solving the real problem and that is the lack of RTL support in Gnome-Terminal.

That's my opinion anyway.

Usama Akkad (damascene) wrote :

>MLTerm is not a Gnome app, it looks ugly and doesn't fit well with the Gnome desktop.

ugly? no. you looked at outdated pictures here are some fresh ones:
http://img405.imageshack.us/img405/5046/mlterm.png
http://uppix.net/6/2/6/ad60d642745d645d0390d78d41d95.png
http://dl.dropbox.com/u/2027572/linuxac/various/Screenshot-Untitled%20Window-1.png
http://img231.imageshack.us/img231/910/mltermkarmic.png

and there is even a youtube comparison shows that the gnome terminal is the one ugly for right to left

http://www.youtube.com/watch?v=3H_HYkyD7wc

Konsole is using a workaround similar to bicon which could be used for vte but it has many bugs and not maintained any more and his maintainer is the same vte maintainer so he could have used it him self. and Konsole has its owen issues with rtl. mlterm is simply the best for rtl users.

I must agree with Shlomil, MLTerm does look worse than Gnome terminal, not
to talk about how limited it is.
we should just push to solve the bug in Terminal rather than finding other
programs. as Shlomil said, I believe that enough pushing the system will
make Gnome to fix it.

2010/4/21 Usama Akkad <email address hidden>

> >MLTerm is not a Gnome app, it looks ugly and doesn't fit well with the
> Gnome desktop.
>
> ugly? no. you looked at outdated pictures here are some fresh ones:
> http://img405.imageshack.us/img405/5046/mlterm.png
> http://uppix.net/6/2/6/ad60d642745d645d0390d78d41d95.png
>
> http://dl.dropbox.com/u/2027572/linuxac/various/Screenshot-Untitled%20Window-1.png
> http://img231.imageshack.us/img231/910/mltermkarmic.png
>
> and there is even a youtube comparison shows that the gnome terminal is
> the one ugly for right to left
>
> http://www.youtube.com/watch?v=3H_HYkyD7wc
>
> Konsole is using a workaround similar to bicon which could be used for
> vte but it has many bugs and not maintained any more and his maintainer
> is the same vte maintainer so he could have used it him self. and
> Konsole has its owen issues with rtl. mlterm is simply the best for rtl
> users.
>
> --
> Selecting an RTL language should install and RTL capable terminal emulator
> https://bugs.launchpad.net/bugs/562130
> You received this bug notification because you are a member of Ubuntu
> Hebrew Translators, which is a direct subscriber.
>
> _______________________________________________
> Mailing list: https://launchpad.net/~ubuntu-l10n-he
> Post to : <email address hidden>
> Unsubscribe : https://launchpad.net/~ubuntu-l10n-he
> More help : https://help.launchpad.net/ListHelp
>

Uri Shabtay (uri.shabtay) wrote :

IMHO, pushing our request could take quite awhile without the proper help
from big-league contributors.. we should make as much noise as possible,
regardless to the decision -- as long as RTL languages will be fully
supported, whether within the Gnome-Terminal or MLTerm

On Wed, Apr 21, 2010 at 10:38 PM, Ddorda <email address hidden> wrote:

> I must agree with Shlomil, MLTerm does look worse than Gnome terminal, not
> to talk about how limited it is.
> we should just push to solve the bug in Terminal rather than finding other
> programs. as Shlomil said, I believe that enough pushing the system will
> make Gnome to fix it.
>
> 2010/4/21 Usama Akkad <email address hidden>
>
> > >MLTerm is not a Gnome app, it looks ugly and doesn't fit well with the
> > Gnome desktop.
> >
> > ugly? no. you looked at outdated pictures here are some fresh ones:
> > http://img405.imageshack.us/img405/5046/mlterm.png
> > http://uppix.net/6/2/6/ad60d642745d645d0390d78d41d95.png
> >
> >
> http://dl.dropbox.com/u/2027572/linuxac/various/Screenshot-Untitled%20Window-1.png
> > http://img231.imageshack.us/img231/910/mltermkarmic.png
> >
> > and there is even a youtube comparison shows that the gnome terminal is
> > the one ugly for right to left
> >
> > http://www.youtube.com/watch?v=3H_HYkyD7wc
> >
> > Konsole is using a workaround similar to bicon which could be used for
> > vte but it has many bugs and not maintained any more and his maintainer
> > is the same vte maintainer so he could have used it him self. and
> > Konsole has its owen issues with rtl. mlterm is simply the best for rtl
> > users.
> >
> > --
> > Selecting an RTL language should install and RTL capable terminal
> emulator
> > https://bugs.launchpad.net/bugs/562130
> > You received this bug notification because you are a member of Ubuntu
> > Hebrew Translators, which is a direct subscriber.
> >
> > _______________________________________________
> > Mailing list: https://launchpad.net/~ubuntu-l10n-he<https://launchpad.net/%7Eubuntu-l10n-he>
> > Post to : <email address hidden>
> > Unsubscribe : https://launchpad.net/~ubuntu-l10n-he<https://launchpad.net/%7Eubuntu-l10n-he>
> > More help : https://help.launchpad.net/ListHelp
> >
>
> --
> Selecting an RTL language should install and RTL capable terminal emulator
> https://bugs.launchpad.net/bugs/562130
> You received this bug notification because you are a member of Ubuntu
> Hebrew Translators, which is a direct subscriber.
>
> _______________________________________________
> Mailing list: https://launchpad.net/~ubuntu-l10n-he<https://launchpad.net/%7Eubuntu-l10n-he>
> Post to : <email address hidden>
> Unsubscribe : https://launchpad.net/~ubuntu-l10n-he<https://launchpad.net/%7Eubuntu-l10n-he>
> More help : https://help.launchpad.net/ListHelp
>

Usama Akkad (damascene) wrote :

@Yaron could you sort things out with your team and come up with one decision?
I see they only disagree and want to push and make noise

Usama Akkad (damascene) on 2010-04-22
summary: - Selecting an RTL language should install and RTL capable terminal
- emulator
+ Selecting an RTL language should install RTL capable terminal emulator

@Usama I can partly agree with you but this is the true meaning of
brainstorming, we should hear all the suggestions before making a decision

We were locked on MLTerm while the idea brought by Shlomi to fix the
terminal according to the algorithm presented by Konsole was quite good and
actual

The reason this system is public and not private is that people could see
what you have in mind and suggest ways of making it better, sometimes its
making things harder and sometimes problems are solved at no-time

I think my position will help sort things out, until we will have the
required resources to fix gnome-terminal we should push MLTerm as default
with each installation (just like Debian does)
Meanwhile we should work together to help fix the bug in vte
(gnome-terminal) according to the algorithm presented by Konsole, this way
MLTerm will only be a temporary solution like it should be...
After the problem is solved you will have to install it manually and it will
not be installed by default

Another important things we should do first:
1. Check whether the Konsole developers are willing to help on this matter
2. Check with the vte developers if our solution is feasible (We can just
add a comment to the upstream bug, nothing more that that)
3. We could try and contact the ssh developers (a little more complicated)
and see if we can get their support (apparently they present a pretty good
support for RTL in ssh as well)

Does anyone disagree?
Yaron Shahrabani

Shlomil (shlomister) wrote :

Usama:
Yes. MLTerm is ugly - it doesn't have Gome-terminal's options, menu, scroll-bar, opacity and other features.
The reason is simple enough - it's not a Gnome application. it was written directly in X API (AFAIK).
If MLTerm will be ever included in RTL installations by default as this bug suggests then it should be known and agreed that it's only a temporary solution - a workaround for the real problem.

Besides that, as Yaron said before, I think people are entitled to hold their own opinion and speak of it publicly.
You have a different opinion and I respect that.

Yaron:
If we want to fix Gnome-terminal we should first come up with a design that Behdad Esfahbod will approve. He will accept a patch only if it is using the "right approach" to solve the problem. Behdad claims that none of the existing terminal emulators he knows solve the problem correctly. I can only guess that he knows about the existence of MLTerm as RTL enabled terminal and he probably found some flaws in it's methods of dealing with RTL text.

The problem with this bug report you opened, is that it doesn't show the
problem and tries to find a solution, but gives a solution as the only thing
may happen.
as i said in my blog post, and as i was backuped, the Terminal is NOT
supposed to support RTL languages, as it is not for dummy users, but for
more advanced. the real solution is to find a way removing all language
translations from the CLI.

2010/4/22 Shlomil <email address hidden>

> Usama:
> Yes. MLTerm is ugly - it doesn't have Gome-terminal's options, menu,
> scroll-bar, opacity and other features.
> The reason is simple enough - it's not a Gnome application. it was written
> directly in X API (AFAIK).
> If MLTerm will be ever included in RTL installations by default as this bug
> suggests then it should be known and agreed that it's only a temporary
> solution - a workaround for the real problem.
>
> Besides that, as Yaron said before, I think people are entitled to hold
> their own opinion and speak of it publicly.
> You have a different opinion and I respect that.
>
> Yaron:
> If we want to fix Gnome-terminal we should first come up with a design that
> Behdad Esfahbod will approve. He will accept a patch only if it is using the
> "right approach" to solve the problem. Behdad claims that none of the
> existing terminal emulators he knows solve the problem correctly. I can only
> guess that he knows about the existence of MLTerm as RTL enabled terminal
> and he probably found some flaws in it's methods of dealing with RTL text.
>
> --
> Selecting an RTL language should install RTL capable terminal emulator
> https://bugs.launchpad.net/bugs/562130
> You received this bug notification because you are a member of Ubuntu
> RTL, which is a direct subscriber.
>
> Status in “language-selector” package in Ubuntu: Triaged
>
> Bug description:
> Binary package hint: language-selector
>
> the default terminal gnome-terminal which is using vte is not able to
> display RTL text like Arabic,Farsi, Urdu or Hebrew and it's a known bug
> that is not likly to be fixed at all as vte developer said. see bug #263822
>
> How ever Mlterm is ready to support variant of scripts including Arabic
> ,Hebrew and even Chinese.
> see https://wiki.ubuntu.com/Mlterm
>
> problem:
> no terminal with RTL support
>
> fix:
> installing Mlterm for RTL by default
>
> ProblemType: Bug
> DistroRelease: Ubuntu 10.04
> Package: language-selector 0.5.4
> ProcVersionSignature: Ubuntu 2.6.32-20.29-generic-pae 2.6.32.11+drm33.2
> Uname: Linux 2.6.32-20-generic-pae i686
> Architecture: i386
> CheckboxSubmission: 4190bdfb1b8df71969b6cbad70f1beb6
> CheckboxSystem: 9c26adf6eed2f681ba41f94dd24c07e4
> Date: Tue Apr 13 11:38:45 2010
> EcryptfsInUse: Yes
> InstallationMedia: Ubuntu-Netbook 10.04 "Lucid Lynx" - Alpha i386
> (20100113)
> PackageArchitecture: all
> ProcEnviron:
> LANG=ar_SA.utf8
> SHELL=/bin/bash
> SourcePackage: language-selector
>
>
>
>
>

Yaron (sh-yaron) wrote :

@Shlomi, I never proposed an approach to dealing with the problem, I just
said what we should do in order to find the right approach

In the meanwhile I support adding the MLTerm as default, this will give us
the temporary solution we need until we can get vte to work as expected...
Yaron Shahrabani

Usama Akkad (damascene) wrote :
Usama Akkad (damascene) wrote :

as my Main Inclusion Request for Mlter got refused thanks to people with no solution. I noticed that there is some packages or machine drivers install packages from outside Main and some times form outside Ubuntu repo like the case with printing drivers. I've found this repo http://www.openprinting.org/download/printdriver/debian/ installed after trying to install Toshiba drivers and similar thing with flash plug-in installer.

realy this a big problem for us in ubuntu why ubuntu make mlterm is automatic.

i mean why ubunut dosen't make mlterm automatic in terminal.

slmb (fqa101) on 2010-09-27
security vulnerability: no → yes
visibility: public → private
Charlie Kravetz (charlie-tca) wrote :

Please don't mark bugs as security issues without an explanation. Removing securtiy and private bug designations.

security vulnerability: yes → no
visibility: private → public
ha el rai (haelrai) wrote :

this bug effects me too

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.